"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return createImagePreview;
    }
});
const _react = /*#__PURE__*/ _interop_require_wildcard(require("react"));
const _client = require("react-dom/client");
const _antd = require("antd");
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function App({ images =[] , current =0 , onClose  }) {
    var _images_filter;
    const [visible, setVisible] = (0, _react.useState)(false);
    (0, _react.useEffect)(()=>{
        setVisible(true);
    }, []);
    return /*#__PURE__*/ _react.default.createElement("div", {
        style: {
            display: "none"
        }
    }, /*#__PURE__*/ _react.default.createElement(_antd.Image.PreviewGroup, {
        preview: {
            visible,
            onVisibleChange: (vis)=>{
                setVisible(vis);
                if (!vis) {
                    onClose === null || onClose === void 0 ? void 0 : onClose();
                }
            },
            current
        }
    }, (_images_filter = images === null || images === void 0 ? void 0 : images.filter(Boolean)) === null || _images_filter === void 0 ? void 0 : _images_filter.map((img)=>/*#__PURE__*/ _react.default.createElement(_antd.Image, {
            key: img,
            src: img
        }))));
}
function createImagePreview({ onClose , ...rest }) {
    setTimeout(()=>{
        const div = document.createElement("div");
        div.setAttribute("role", "Dynamically created preview");
        document.body.appendChild(div);
        const root = (0, _client.createRoot)(div);
        function destory() {
            setTimeout(()=>{
                root.unmount();
                document.body.removeChild(div);
            // console.log('destoryed preview');
            });
        }
        root.render(/*#__PURE__*/ _react.default.createElement(App, {
            ...rest,
            onClose: ()=>{
                setTimeout(()=>{
                    destory();
                }, 200);
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        }));
    });
}
