"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    // import LocaleReceiver from 'antd/es/locale-provider/LocaleReceiver';
    // import { ModalLocale } from 'antd/es/modal/locale';
    /**
 * @description Create a one-off modal dialog dynamically without maintenance loading and visible.
 * @description.zh-CN 动态创建一次性的模态框，不需要维护 loading 和 visible。
 */ default: function() {
        return createModal;
    },
    createFunctionWithDefaultProps: function() {
        return createFunctionWithDefaultProps;
    },
    useModalCreation: function() {
        return _useModalCreation.useModalCreation;
    }
});
const _react = /*#__PURE__*/ _interop_require_default(require("react"));
const _client = require("react-dom/client");
const _component = require("./component");
const _useModalCreation = require("./useModalCreation");
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function createModal(params) {
    let _resolve, _reject;
    const defered = new Promise((resolve, reject)=>{
        _reject = reject;
        _resolve = resolve;
    });
    const div = document.createElement("div");
    div.setAttribute("role", "Dynamically created modal");
    document.body.appendChild(div);
    let root = null;
    function destory() {
        setTimeout(()=>{
            root === null || root === void 0 ? void 0 : root.unmount();
            document.body.removeChild(div);
            _reject("destory");
        });
    }
    /**
   * https://github.com/ant-design/ant-design/issues/23623
   * Sync render blocks React event. Let's make this async.
   */ setTimeout(()=>{
        root = (0, _client.createRoot)(div);
        root.render(/*#__PURE__*/ _react.default.createElement(_component.TmpComp, {
            afterClose: destory,
            ...params,
            onOk: (values)=>{
                var _params_onOk;
                const Result = (_params_onOk = params.onOk) === null || _params_onOk === void 0 ? void 0 : _params_onOk.call(params, values);
                _resolve(Result || values);
                return Result;
            },
            // onFailed={async (error) => {
            //   reject(await params.onFailed?.(error));
            // }}
            onCancel: (e)=>{
                var _params_onCancel;
                (_params_onCancel = params.onCancel) === null || _params_onCancel === void 0 ? void 0 : _params_onCancel.call(params, e);
                _reject("cancel");
            }
        }));
    });
    return {
        destory,
        promise: defered
    };
}
function createFunctionWithDefaultProps(defaultParams) {
    const newFunction = (params)=>createModal({
            ...defaultParams,
            ...params
        });
    return newFunction;
}
