"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "useModalCreation", {
    enumerable: true,
    get: function() {
        return useModalCreation;
    }
});
const _react = /*#__PURE__*/ _interop_require_default(require("react"));
const _usePatchElement = /*#__PURE__*/ _interop_require_default(require("antd/es/_util/hooks/usePatchElement"));
const _component = require("./component");
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
let uuid = 0;
const ElementsHolder = /*#__PURE__*/ _react.default.memo(/*#__PURE__*/ _react.default.forwardRef((_props, ref)=>{
    const [elements, patchElement] = (0, _usePatchElement.default)();
    _react.default.useImperativeHandle(ref, ()=>({
            patchElement
        }), []);
    // eslint-disable-next-line react/jsx-no-useless-fragment
    return /*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, elements);
}));
function useModalCreation(defaultProps) {
    const holderRef = _react.default.useRef(null);
    const createModal = _react.default.useCallback(/**
     * @description Create a one-off modal dialog dynamically without maintenance loading and visible.
     * @description.zh-CN 动态创建一次性的模态框，不需要维护 loading 和 visible。
     */ function createModal(params) {
        let _resolve, _reject;
        const defered = new Promise((resolve, reject)=>{
            _reject = reject;
            _resolve = resolve;
        });
        let unmountFunc;
        function destory() {
            setTimeout(()=>{
                unmountFunc === null || unmountFunc === void 0 ? void 0 : unmountFunc();
                _reject("destory");
            });
        }
        /**
       * https://github.com/ant-design/ant-design/issues/23623
       * Sync render blocks React event. Let's make this async.
       */ setTimeout(()=>{
            var _holderRef_current;
            unmountFunc = (_holderRef_current = holderRef.current) === null || _holderRef_current === void 0 ? void 0 : _holderRef_current.patchElement(/*#__PURE__*/ _react.default.createElement(_component.TmpComp, {
                key: `modal-${uuid++}`,
                afterClose: destory,
                ...defaultProps,
                ...params,
                onOk: (values)=>{
                    var _params_onOk;
                    const Result = (_params_onOk = params.onOk) === null || _params_onOk === void 0 ? void 0 : _params_onOk.call(params, values);
                    _resolve(Result || values);
                    return Result;
                },
                onCancel: (e)=>{
                    var _params_onCancel;
                    (_params_onCancel = params.onCancel) === null || _params_onCancel === void 0 ? void 0 : _params_onCancel.call(params, e);
                    _reject("cancel");
                }
            }));
        });
        return {
            destory,
            promise: defered
        };
    }, []);
    return [
        /*#__PURE__*/ _react.default.createElement(ElementsHolder, {
            key: "modal-holder",
            ref: holderRef
        }),
        createModal
    ];
}
