import React, { useEffect, useState } from "react";
import { createRoot } from "react-dom/client";
import { Image } from "antd";
function App({ images =[] , current =0 , onClose  }) {
    var _images_filter;
    const [visible, setVisible] = useState(false);
    useEffect(()=>{
        setVisible(true);
    }, []);
    return /*#__PURE__*/ React.createElement("div", {
        style: {
            display: "none"
        }
    }, /*#__PURE__*/ React.createElement(Image.PreviewGroup, {
        preview: {
            visible,
            onVisibleChange: (vis)=>{
                setVisible(vis);
                if (!vis) {
                    onClose === null || onClose === void 0 ? void 0 : onClose();
                }
            },
            current
        }
    }, (_images_filter = images === null || images === void 0 ? void 0 : images.filter(Boolean)) === null || _images_filter === void 0 ? void 0 : _images_filter.map((img)=>/*#__PURE__*/ React.createElement(Image, {
            key: img,
            src: img
        }))));
}
export default function createImagePreview({ onClose , ...rest }) {
    setTimeout(()=>{
        const div = document.createElement("div");
        div.setAttribute("role", "Dynamically created preview");
        document.body.appendChild(div);
        const root = createRoot(div);
        function destory() {
            setTimeout(()=>{
                root.unmount();
                document.body.removeChild(div);
            // console.log('destoryed preview');
            });
        }
        root.render(/*#__PURE__*/ React.createElement(App, {
            ...rest,
            onClose: ()=>{
                setTimeout(()=>{
                    destory();
                }, 200);
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        }));
    });
}
